## About The project

## Install Streamlit

```shell
pip install streamlit
pip install st-pages
```

```shell
pip install httpx[http2]
pip install youtube-transcript-api
```

## Start Project

```shell
streamlit run Homepage.py
```

## Installing with `nix`

Begin by installing the `nix` package manager from https://nixos.org/download

Then enter a shell with all the required dependencies:
```console
$ nix -L develop
```

You should then be able to run `streamlit` as usual:
```console
$ (cd Streamlit && streamlit run Homepage.py)
```

### Updating `Nixpkgs`

If you want to use another version of Nixpkgs,
instead of the one pinned in `flake.lock`,
you can update `flake.lock` to either your system's version:
```console
$ nix flake lock --update-input nixpkgs
```

Or a specific version:
```console
nix flake lock --override-input nixpkgs github:NixOS/nixpkgs/d4b5a67bbe9ef750bd2fdffd4cad400dd5553af8
```

Changing Nixpkgs' version might obviously cause breakages.


## About YTB to TSV tool

After encoutering many problems with the Youtube spam detection and blacklist, this tool has been suspended until further update if a solution happens to be found.

When the request to obtain the generated translation are made, Youtube start to block the programm after an undetermined number of requests to avoid spams.
Even after the implementation of a random delay between each request, it still occurs.

Another way to get the translations would be to use an API but most of them ask for personnal key or id, and the one which don't, Google Translate, is too much slow for all the translations.

Finally, the search of videos only with substitles in asked languages isn't proefficient enough, making the number of videos goten from that lower than the number the user ask for.
